<?php
/*
Plugin Name: Auto Info
Plugin URI: http://www.de-mas.net/autoinfo-wordpress-plugin
Description: Plugin to show some information about your blog (number of posts, number of users, Pagerank, Alexa Rank,...).
Author: Eduard Fernandez
Version: 1.0
Author URI: http://www.eduardfernandez.com/
*/ 

/*
Copyright 2007 Eduard Fernandez (eduardmail@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//PageRank Lookup v1.1 by HM2K (update: 31/01/07)
//based on an alogoritham found here: http://pagerank.gamesaga.net/

/* Funcion principal */
function autoinfo() 
{
	global $wpdb;

	$var_user_count = get_option('var_user_count');
	$var_post_count = get_option('var_post_count');
	$var_user_online = get_option('var_user_online');
	$var_ping_count = get_option('var_ping_count');
	$var_post_ping = get_option('var_post_ping');
	$var_comm_count = get_option('var_comm_count');
	$var_post_comm = get_option('var_post_comm');
	$var_top3_users = get_option('var_top3_users');
	$var_rank_google = get_option('var_rank_google');
	$var_rank_alexa = get_option('var_rank_alexa');
	$var_feed_count = get_option('var_feed_count');
	$var_top3_post = get_option('var_top3_post');
	$var_show_ads = get_option('var_show_ads');
	$var_link_own = get_option('var_link_own');

	$post_count = (int) $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish'");
	$comm_count = (int) $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->comments WHERE comment_approved = '1'");
	$ping_count = (int) $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->comments WHERE comment_type = 'pingback';");

	echo '<ul>';
	/* Chequeando que vamos a mostrar */
	if ($var_user_online)
	{
		$user_online = online_users();
		echo '<li><strong>Users Online:</strong> ' . $user_online . '</li>';
	}
	if ($var_user_count)
	{
		$user_count = (int) $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->users;");
		echo '<li><strong>Registered Users:</strong> ' . $user_count . '</li>';
	}
	if ($var_feed_count)
	{
		$feedburnerfeed="http://feeds.feedburner.com/".get_option('var_feed_url');
		$feedcount=getfeedburner($feedburnerfeed);
		$rss_gif=get_settings('siteurl')."/wp-content/plugins/rss.gif";
		echo '<li><strong>Feed Subscribers:</strong> '.$feedcount.' <a href="'.$feedburnerfeed.'" rel="nofollow"><img src="'.$rss_gif.'" border="0" align="baseline" /></a></li>';
	}
	if ($var_post_count)
	{
		echo '<li><strong>Posts:</strong> ' . $post_count . '</li>';
	}
	if ($var_ping_count)
	{
		echo '<li><strong>Links to posts:</strong> ' . $ping_count . '</li>';
	}
	if ($var_post_ping)
	{
		$post_ping = number_format($ping_count/$post_count,2);
		echo '<li><strong>Links per post:</strong> ' . $post_ping . '</li>';
	}
	if ($var_top3_post)
	{
		$top3_posts =  (Array) $wpdb->get_results("SELECT $wpdb->posts.ID, $wpdb->posts.post_title, $wpdb->posts.comment_count FROM $wpdb->posts ORDER BY $wpdb->posts.comment_count DESC LIMIT 3;");
		echo '<li><strong>Top3 commented posts:</strong> ';
		foreach ($top3_posts as $top3_post) 
		{
			$post_link=get_permalink($top3_post->ID);
			echo '<a href="' . $post_link . '">' . $top3_post->post_title . '</a> (' . $top3_post->comment_count .') ';
		}
		echo '</li>';
	}
	if ($var_comm_count)
	{	
		echo '<li><strong>Comments:</strong> ' . $comm_count . '</li>';
	}
	if ($var_post_comm)
	{	
		$post_comm = number_format($comm_count/$post_count,2);
		echo '<li><strong>Comments per post:</strong> ' . $post_comm . '</li>';
	}
	if ($var_top3_users)
	{
		$top3_users =  (Array) $wpdb->get_results("SELECT $wpdb->comments.comment_author, COUNT(*) AS cuantos FROM $wpdb->comments WHERE $wpdb->comments.comment_approved='1' GROUP BY $wpdb->comments.comment_author ORDER BY cuantos DESC LIMIT 3;");
		echo '<li><strong>Top3 commenters:</strong> ';
		foreach ($top3_users as $top3_user) 
		{
			echo '-' . $top3_user->comment_author . ' (' . $top3_user->cuantos .') ';
		}
		echo '</li>';
	}
	if ($var_rank_google)
	{
		$url=$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
		$pagerank=getpr($url);
		echo '<li><strong>Pagerank:</strong> '.$pagerank.'</li>';
	}
	if ($var_rank_alexa)
	{
		$url=$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
		$alexarank=getarank($url);
		echo '<li><strong>Alexarank:</strong> '.$alexarank.'</li>';
	}
	if ($var_show_ads)
	{
		$var_show_text = get_option('var_show_text');
		$var_show_url = get_option('var_show_url');
		echo '<li><strong><a href="'.$var_show_url.'">'.$var_show_text.'</a></strong></li>';
	}
	if ($var_link_own)
	{
		echo '<li><small align="right">Powered by <a href="http://www.de-mas.net" target="_blank">D+</a></small></li>';
	}
	echo '</ul>';

}

/* Funcion para saber el numero de suscriptores en FeedBurner */
function getfeedburner ($feedburnerfeed) 
{ 
	$fbhost="api.feedburner.com";
	$fbua='Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.6) Gecko/20060728 Firefox/1.5';
	$url=urlencode($feedburnerfeed);
	$fp = fsockopen($fbhost, 80, $errno, $errstr, 30);
	if ($fp) 
	{
		$out = "GET /awareness/1.0/GetFeedData?uri=$url \r\n";
		$out .= "User-Agent: $fbua\r\n";
		$out .= "Host: $fbhost\r\n";
		$out .= "Connection: Close\r\n\r\n";
		fwrite($fp, $out);
		$contents = '';
		while (!feof($fp)) 
		{
			$contents .= fread($fp, 8192);
		}
		preg_match('/\<entry date\="(.*?)" circulation\="([0-9]+)" hits\="(.*?)" \/\>/si', $contents, $r);
		fclose($fp);
		return ($r[2]) ? $r[2] : '0';
	}
} 

/* Funcion para obtener el valor del ranking de Alexa */
function getarank ($url) 
{ 
	$alexahost="data.alexa.com";
	$alexaua='Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.6) Gecko/20060728 Firefox/1.5';
	$url=urlencode($url);
	$fp = fsockopen($alexahost, 80, $errno, $errstr, 30);
	if ($fp) 
	{
		$out = "GET /data?cli=10&dat=snbamz&url=$url \r\n";
		$out .= "User-Agent: $alexaua\r\n";
		$out .= "Host: $alexahost\r\n";
		$out .= "Connection: Close\r\n\r\n";
		fwrite($fp, $out);
		$contents = '';
		while (!feof($fp))
		{
			$contents .= fread($fp, 8192);
		}
		preg_match('/\<popularity url\="(.*?)" TEXT\="([0-9]+)"\/\>/si', $contents, $r);
		fclose($fp);
		return ($r[2]) ? $r[2] : '0';
	}
} 

/* Funcion para obtener el valor del Pagerank */
function getpr($url) {
	$googlehost='toolbarqueries.google.com';
	$googleua='Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.6) Gecko/20060728 Firefox/1.5';
	$ch = getch($url);
	$fp = fsockopen($googlehost, 80, $errno, $errstr, 30);
	
	if ($fp) 
	{
		$out = "GET /search?client=navclient-auto&ch=$ch&features=Rank&q=info:$url HTTP/1.1\r\n";
		$out .= "User-Agent: $googleua\r\n";
		$out .= "Host: $googlehost\r\n";
		$out .= "Connection: Close\r\n\r\n";
		fwrite($fp, $out);
	   
		while (!feof($fp)) 
		{
			$data = fgets($fp, 128);
			$pos = strpos($data, "Rank_");
			if($pos === false){} else{
				$pr=substr($data, $pos + 9);
				$pr=trim($pr);
				$pr=str_replace("\n",'',$pr);
			}
		}
		return ($pr);
		fclose($fp);
	}
}

/* Convertir un string a un entero de 32-bits - Para la funcion getpr */
function StrToNum($Str, $Check, $Magic) {
    $Int32Unit = 4294967296;  // 2^32
    $length = strlen($Str);
    for ($i = 0; $i < $length; $i++) {
        $Check *= $Magic; 	
        if ($Check >= $Int32Unit) {
            $Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit));
            $Check = ($Check < -2147483648) ? ($Check + $Int32Unit) : $Check;
        }
        $Check += ord($Str{$i}); 
    }
    return $Check;
}

/* Genera un hash para la url - Para la funcion getpr */
function HashURL($String) {
    $Check1 = StrToNum($String, 0x1505, 0x21);
    $Check2 = StrToNum($String, 0, 0x1003F);
    $Check1 >>= 2; 	
    $Check1 = (($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F);
    $Check1 = (($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF);
    $Check1 = (($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);	
    $T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F );
    $T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 );
    return ($T1 | $T2);
}

/* Genera un checksum para el hash - Para la funcion getpr */
function CheckHash($Hashnum) {
    $CheckByte = 0;
    $Flag = 0;
    $HashStr = sprintf('%u', $Hashnum) ;
    $length = strlen($HashStr);
	
    for ($i = $length - 1;  $i >= 0;  $i --) 
	{
        $Re = $HashStr{$i};
        if (1 === ($Flag % 2)) {              
            $Re += $Re;     
            $Re = (int)($Re / 10) + ($Re % 10);
        }
        $CheckByte += $Re;
        $Flag ++;	
    }

    $CheckByte %= 10;
    if (0 !== $CheckByte) 
	{
        $CheckByte = 10 - $CheckByte;
        if (1 === ($Flag % 2) ) 
		{
            if (1 === ($CheckByte % 2)) 
			{
                $CheckByte += 9;
            }
            $CheckByte >>= 1;
        }
    }
    return '7'.$CheckByte.$HashStr;
}

/* Devuelve el checksum hasg del pagerank */
function getch($url) { 
	return CheckHash(HashURL($url)); 
}

/* Funcion para saber el numero de usuarios online mediante el fichero online.txt */
function online_users(){ 

	$ip = $_SERVER['REMOTE_ADDR'];
	$time = time();
	$minutes = 1;
	$found = 0;
	$users = 0;
	$user = "";
	
	$path_parts=realpath($_SERVER['PATH_TRANSLATED']);
	if (is_dir($path_parts) && !(substr($path_parts,-1)=="/"))
	{
		$path_parts=$path_parts."/";
		$file_name=$path_parts.'wp-content/plugins/online.txt';
	} else {
		$path_parts=pathinfo($path_parts);
		$file_name=$path_parts['dirname'].'/wp-content/plugins/online.txt';
	}

	/* Si no se encuentra el fichero se mostrar el valor 0 */
	if (!is_file($file_name))
	{ 
		$users="0";
		return ($users);
	} else {
		$f = fopen($file_name,"r+");
		flock($f,2); 

		while (!feof($f)) 
		{ 
			$user[] = chop(fgets($f,65536)); 
		} 

		fseek($f,0,SEEK_SET); 
		ftruncate($f,0); 

		foreach ($user as $line)
		{ 
			list($savedip,$savedtime) = split("\|",$line); 
			if ($savedip == $ip) 
			{
				$savedtime = $time;$found = 1;
			} 
			if ($time < $savedtime + ($minutes * 60)) 
			{ 
				fputs($f,"$savedip|$savedtime\n"); 
				$users = $users + 1; 
			} 
		} 

		if ($found == 0)
		{ 
			fputs($f,"$ip|$time\n"); 
			$users = $users + 1; 
		} 

		fclose ($f);
		return ($users);
	}
} 

/* Panel de Control */
function autoinfo_fetch_options() {
	$output = array();

	$output['var_user_count'] = get_option('var_user_count');
	$output['var_post_count'] = get_option('var_post_count');
	$output['var_user_online'] = get_option('var_user_online');
	$output['var_ping_count'] = get_option('var_ping_count');
	$output['var_post_ping'] = get_option('var_post_ping');
	$output['var_comm_count'] = get_option('var_comm_count');
	$output['var_post_comm'] = get_option('var_post_comm');
	$output['var_top3_users'] = get_option('var_top3_users');
	$output['var_rank_google'] = get_option('var_rank_google');
	$output['var_rank_alexa'] = get_option('var_rank_alexa');
	$output['var_feed_url'] = get_option('var_feed_url');
	$output['var_feed_count'] = get_option('var_feed_count');
	$output['var_top3_post'] = get_option('var_top3_post');
	$output['var_show_ads'] = get_option('var_show_ads');
	$output['var_show_text'] = get_option('var_show_text');
	$output['var_show_url'] = get_option('var_show_url');
	$output['var_link_own'] = get_option('var_link_own');

	return $output;
}

function autoinfo_options_page() 
{
	$version = "1.0";

	if (isset($_POST['info_update']))
	{
		if ($_POST['autoinfo_settings']['var_user_count'])
		{
			update_option('var_user_count',1);
		} else {
			update_option('var_user_count',0);
		}
		if ($_POST['autoinfo_settings']['var_post_count'])
		{
			update_option('var_post_count',1);
		} else {
			update_option('var_post_count',0);
		}
		if ($_POST['autoinfo_settings']['var_user_online'])
		{
			update_option('var_user_online',1);
		} else {
			update_option('var_user_online',0);
		}
		if ($_POST['autoinfo_settings']['var_ping_count'])
		{
			update_option('var_ping_count',1);
		} else {
			update_option('var_ping_count',0);
		}
		if ($_POST['autoinfo_settings']['var_post_ping'])
		{
			update_option('var_post_ping',1);
		} else {
			update_option('var_post_ping',0);
		}
		if ($_POST['autoinfo_settings']['var_comm_count'])
		{
			update_option('var_comm_count',1);
		} else {
			update_option('var_comm_count',0);
		}
		if ($_POST['autoinfo_settings']['var_post_comm'])
		{
			update_option('var_post_comm',1);
		} else {
			update_option('var_post_comm',0);
		}
		if ($_POST['autoinfo_settings']['var_top3_users'])
		{
			update_option('var_top3_users',1);
		} else {
			update_option('var_top3_users',0);
		}
		if ($_POST['autoinfo_settings']['var_rank_google'])
		{
			update_option('var_rank_google',1);
		} else {
			update_option('var_rank_google',0);
		}
		if ($_POST['autoinfo_settings']['var_rank_alexa'])
		{
			update_option('var_rank_alexa',1);
		} else {
			update_option('var_rank_alexa',0);
		}
		if ($_POST['autoinfo_settings']['var_feed_count'])
		{
			update_option('var_feed_count',1);
		} else {
			update_option('var_feed_count',0);
		}
		if ($_POST['autoinfo_settings']['var_top3_post'])
		{
			update_option('var_top3_post',1);
		} else {
			update_option('var_top3_post',0);
		}
		if ($_POST['autoinfo_settings']['var_show_ads'])
		{
			update_option('var_show_ads',1);
		} else {
			update_option('var_show_ads',0);
		}
		if ($_POST['autoinfo_settings']['var_link_own'])
		{
			update_option('var_link_own',1);
		} else {
			update_option('var_link_own',0);
		}
		update_option('var_show_text',$_POST['autoinfo_settings']['var_show_text']);
		update_option('var_show_url',$_POST['autoinfo_settings']['var_show_url']);
		update_option('var_feed_url',$_POST['autoinfo_settings']['var_feed_url']);
	} 
	$autoinfo_settings = autoinfo_fetch_options();
?>

<?PHP if (isset($_POST['info_update'])) {?><div id="message" class="updated fade"><p><strong>Options Saved</strong></p></div><?PHP } ?>

<div class=wrap>
  <form method="post">
    <h2>Auto Info Configuration</h2>

	<fieldset name="Paginas">
		<legend>Check what to show</legend>
			<INPUT type="checkbox" name="autoinfo_settings[var_user_online]" value="1" <?php if ($autoinfo_settings['var_user_online']){ echo "checked";}?>><label>Number of online users</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_user_count]" value="1" <?php if ($autoinfo_settings['var_user_count']){ echo "checked";}?>><label>N&uacute;mer of registered users</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_feed_count]" value="1" <?php if ($autoinfo_settings['var_feed_count']){ echo "checked";}?>><label>Number of FeedBurner subscribers for: http://feeds.feedburner.com/</label><INPUT type="text" name="autoinfo_settings[var_feed_url]" value="<?php echo $autoinfo_settings['var_feed_url']; ?>"><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_post_count]" value="1" <?php if ($autoinfo_settings['var_post_count']){ echo "checked";}?>><label>Number of posts</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_ping_count]" value="1" <?php if ($autoinfo_settings['var_ping_count']){ echo "checked";}?>><label>Number of links (pingbacks)</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_post_ping]" value="1" <?php if ($autoinfo_settings['var_post_ping']){ echo "checked";}?>><label>Links per post relation</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_top3_post]" value="1" <?php if ($autoinfo_settings['var_top3_post']){ echo "checked";}?>><label>Top3 most commented posts</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_comm_count]" value="1" <?php if ($autoinfo_settings['var_comm_count']){ echo "checked";}?>><label>Number of comments</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_post_comm]" value="1" <?php if ($autoinfo_settings['var_post_comm']){ echo "checked";}?>><label>Comments per post relation</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_top3_users]" value="1" <?php if ($autoinfo_settings['var_top3_users']){ echo "checked";}?>><label>Top3 commenters</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_rank_google]" value="1" <?php if ($autoinfo_settings['var_rank_google']){ echo "checked";}?>><label>PageRank</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_rank_alexa]" value="1" <?php if ($autoinfo_settings['var_rank_alexa']){ echo "checked";}?>><label>AlexaRank</label><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_show_ads]" value="1" <?php if ($autoinfo_settings['var_show_ads']){ echo "checked";}?>><label>Link for advertisers: </label><label> Text to show: </label><INPUT type="text" name="autoinfo_settings[var_show_text]" value="<?php echo $autoinfo_settings['var_show_text']; ?>"><label> Target URL: </label><INPUT type="text" name="autoinfo_settings[var_show_url]" value="<?php echo $autoinfo_settings['var_show_url']; ?>"><br />
			<INPUT type="checkbox" name="autoinfo_settings[var_link_own]" value="1" <?php if ($autoinfo_settings['var_link_own']){ echo "checked";}?>><label>Thanks link to the official plugin page</label><br />
	</fieldset>	
<div class="submit">
  <input type="submit" name="info_update" value="<?php _e('Update', 'Localization name')?>" />
</div>
 </form>
</div>

<?php
}

add_option('var_user_count', 1);
add_option('var_post_count', 1);
add_option('var_ping_count', 1);
add_option('var_post_ping', 1);
add_option('var_comm_count', 1);
add_option('var_post_comm', 1);
add_option('var_rank_google', 1);
add_option('var_rank_alexa', 1);
add_option('var_feed_url', 'yoursite');
add_option('var_show_text', 'Advertise in this site');
add_option('var_show_url', get_settings('siteurl').'/conctact.html');
add_option('var_link_own', 1);

if (isset($wp_version))  {
	add_action('admin_menu', 'autoinfo_add_option_page');
}

function autoinfo_add_option_page() {
	add_options_page("AutoInfo Configuration", 'Auto Info', 7, __FILE__, 'autoinfo_options_page');
}
?>